comment~


     230 byte vesa support for 256 colour banked modes
     at least vesa 1.2 required
     no vesacheck! just initialisation to keep size small!

     Feel free to use this in your intros, but I'd really aprecciate
     to be greeted ;)

     Please note, that this code is NOT optimized on size a lot, though
     it's small and slow 'cause of banking and sizesaving routines.
     Due to the compatibilities size grew a bit, but this module can
     handle FIVE screenmodes.
     No documentations this time, I admit you CAN code ;)

     The vesarecords were taken from some starring old code.


 not copyrighted 1998 by PigPen^oCCult


~

CODE SEGMENT
     assume cs:code,ds:code
     p386

;capable of tha followin' modez:
;100h  640x400   256
;101h  640x480   256
;103h  800x600   256
;105h  1024x768  256
;107h  1280x1024 256

mode equ 103h ; set here your desired mode...

ORG 100h

;---------------------------------------------------------[MACROS]------------

vesainit macro
;this macro does initing, setting and getting the modeinformation 
	mov ah,4fh
	push ds
	pop  es
	lea  di,VesaInfo
	int  10h
;set the vesa mode
	xor dx,dx
	mov ax,4F02h
	mov bx,mode
	int 10h
;get the modeinfo
	mov ax,4F01h
	xchg bx,cx
	lea di,VesaModeInfo
	int 10h
endm

calcshiftings macro
;due to differing granularities this will set the right variables up.. :()
	mov ax,64
	div WindowGranularity
	mov BankMult,ax
	mov ax,0ffffh
	mov cx,128
	@@granloop:
	  inc ax
	  shr cx,1
	  cmp cx,WindowGranularity
	jne short @@granloop
	mov BankShiftModifier,ax
endm

;---------------------------------------------------------[MAIN]--------------

startprog:
push cs
pop ds

vesainit
calcshiftings

xor ax,ax
int 16h
mov ax,3
int 10h

ret

;----------------------------------------------------[PROCEDURES]-------------
setbank proc near
;sets a vesa-bank --> number in DX
	pusha
	mov word ptr[curbank],dx
	mov ax,4F05h
	xor bx,bx
	call dword ptr WindowPosFunc
	;you could call int 10h instead of, but this _should_ ;) be faster.
	popa
	ret
endp

;assumes start argument in eax
VesaSetDisplayStart proc near
;I never tested this routine. I never really had use for banked vesa.
	pushad
	movzx	ecx,word ptr[BytesPerScanLine]
	xor	edx,edx
	xor	bx,bx
	div	ecx
	xchg    cx,dx
	xchg    dx,ax
	mov	ax,4F07h
	int	10h
	popad
	ret
endp

;wants: ax/bx = X/Y ; cl=col
putpixel proc near
;huh... LARGE. SLOW. DIRTY. (wuah, pervert! ;)
	pusha
	push cx
	movzx ebx,bx
	movzx edx,WidthInPixels
	imul ebx,edx
	movzx eax,ax
	add ebx,eax
	mov cx,16
	sub cx,BankShiftModifier
	mov edx,ebx
	shr edx,cl
	push dx
	shl edx,cl
	sub ebx,edx
	pop dx
        ;cut the condition for extremely speed wasting size optimization! ;]
	cmp dx,curbank
	je short @@rightbank
	   call setbank
	@@rightbank:
	push 0a000h
	pop es
	mov di,bx
	pop ax
	stosb
	popa
	ret
endp

;clears vesa screen
clear proc near
;I never used this routine too... guess why?
;perhaps its a little bit buggy? ;)
	pusha
	movzx ecx,WidthInPixels
	movzx ebx,HeightInPixels
	imul ecx,ebx
	shr ecx,16
	adc cx,0
	inc cx
	@@clear_all_banks:
	  push cx
	  mov  dx,BankMult
	  imul dx,cx
	  dec  dx
	  call setbank
	  xor  cx,cx
	  dec  cx
	  xor  ax,ax
	  push 0a000h
     	  xor  di,di
	  pop  es
     	  rep  stosw
	  pop cx
	loop @@clear_all_banks
	popa
	ret
endp

;------------------------------------------------------[VARIABLES]------------

Curbank           dw ?
BankShiftModifier dw ?
BankMult          dw ?

Label VesaInfo
Signature	db	4 dup(?)
VesaVersion	dw	?
OEMName		dd	?
Capabilities	db	4 dup(?)
SupportedModes	dd	?
VideoMemory	dw	?
Reserved	db	236 dup(?)

Label VesaModeInfo
ModeAttribs	dw	?
WindowAAttribs	db	?
WindowBAttribs	db	?
WindowGranularity dw	?
WindowSize	dw	?
WindowAStartSeg	dw	?
WindowBStartSeg	dw	?
WindowPosFunc	dd	?
BytesPerScanLine dw	?
WidthInPixels	dw	?
HeightInPixels	dw	?
WidthCharCel	db	?
HeightCharCel	db	?
MemPlanes	db	?
BitsPerPixel	db	?
Banks		db	?
MemoryModelType	db	?
SizeOfBank	db	?
ImagesPages	db	?
Reserved_1	db	?
; Vesa 1.2
RedMaskSize	db	?
RedMaskPosition	db	?
GreenMaskSize	db	?
GreenMaskPosition db	?
BlueMaskSize	db	?
BlueMaskPosition db	?
ReservedMaskSize db	?
ReservedMaskPosition db	?
DirectScreenModeInfo db ?
Reserved_2	db	?
; Vesa 2.0
Misc_1		db	256 dup(?)		;
		db	1024 dup(?)		;


code ends
end startprog

world db nazis raus!
